{+----------------------------------------------------------+
 This version of the TurboSearch Algorithm is copyrighted by
 Angus Johnson 1998. ajohnson@rpi.net.au
 Ask him for the conditions of use.
+------------------------------------------------------------+}

unit AJSearch;

interface

uses
  Windows,
  SysUtils,
  Messages,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  Menus;

type
  TTAJSearch=class(Tobject)
  private
    Text, Pat: String;
    fCount: Integer;
    Jump: array[#0..#255]of Integer;
    intjump        : integer;
    fPos: Integer;
    HalfLen, PatLen, TextLen: Integer;
    fFinished: Boolean;
    fFound: Boolean;
    function GetFinished: Boolean;
  protected
  public
    constructor Create;
    destructor Destroy; override;
    procedure Init(NewPattern: String);
    function FindFirst(NewText: String): Integer;
    function Next: Integer;
    property Count: Integer read fCount write fCount;
    property Finished: Boolean read GetFinished;
    property Found: Boolean read fFound;
  published
  end;

implementation

constructor TTAJSearch.Create;
begin
  inherited Create;
  Pat:='';
  PatLen:=0;
  HalfLen:=0;
  Text:='';
  TextLen:=0;
  fPos:=0;
  fFound:=False;
  fCount:=0;
end; { Create }

function TTAJSearch.GetFinished: Boolean;
begin
  fFinished:=False;
  if fPos>=TextLen then fFinished:=True;
  if PatLen>TextLen then fFinished:=True;
  Result:=fFinished;
end; { GetFinished }

procedure TTAJSearch.Init(NewPattern: String);
var
   j: integer;
   i: char;
begin
  Pat:=NewPattern;
  PatLen:=Length(Pat);

   PatLen := length(Pat);
   if PatLen = 0 then exit;

   for i := #0 to #255 do jump[i]:= PatLen;
   for j := 1 to PatLen-1 do
     jump[Pat[j]]:= PatLen - j;
   intjump := jump[Pat[PatLen]];
   jump[Pat[PatLen]] := 0;
end; { Init }

function TTAJSearch.FindFirst(NewText: String): Integer;
begin
  Text:=NewText;
  TextLen:=Length(Text);
  Result:=0;
  fFound:=False;
  fCount:=0;
  if TextLen>=PatLen then
  begin
    fPos:=0;
    Result:=Next;
  end;
end; { FindFirst }

function TTAJSearch.Next: Integer;
var
   i: integer;
begin
   result:= 0;
   inc(fPos,PatLen-1);
   while fPos < TextLen do
   begin
     i := jump[Text[fPos]]; //test last character first
     if i <> 0 then //last char does not match
       inc(fPos,i)
     else
     begin //last char matches at least
       i := PatLen-1;
       while (i > 0) and
             (Pat[PatLen-i] = Text[fPos-i]) do dec(i);
       if (i <> 0) then
         inc(fPos,intjump)
       else
       begin //FOUND!
          result:= fPos-PatLen+1;
          inc(fPos); //positioned now first character after match.
          exit;
       end;
     end; {if i<>0 ..else..}
   end; {while}
end; { Next }

destructor TTAJSearch.Destroy;
begin
  inherited Destroy;
end; { Destroy }

Initialization
end.

