{+--------------------------------------------------------------------------+
 | Created:     10.97
 | Author:      Martin Waldenburg
 | Copyright    1997, all rights reserved.
 | Description: Demo for mwTSearch.
 | It's provided as is, without a warranty of any kind.
 | You use it at your own risc.
 | E-Mail me at Martin.Waldenburg@t-online.de
 +--------------------------------------------------------------------------+}
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  mwTSearch, mwTSearchO, mwTSearchSJ, mwTSearch1J, StdCtrls, AJSearch, mwFastTime,
  ComCtrls, FileCtrl;

type
  TForm1=class(TForm)
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    StartBtn: TButton;
    Time1: TmwFastTime;
    Edit4: TEdit;
    Edit5: TEdit;
    Edit6: TEdit;
    ProgressBar1: TProgressBar;
    DirectoryListBox1: TDirectoryListBox;
    DriveComboBox1: TDriveComboBox;
    Edit7: TEdit;
    Button1: TButton;
    Label1: TLabel;
    ListBox1: TListBox;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure StartBtnClick(Sender: TObject);
    procedure DriveComboBox1Change(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
  private
    Searched: Integer;
    TempLen: Integer;
    SearchTime: Extended;
    SearchTimeO: Extended;
    SearchTimeSJ: Extended;
    SearchTime1J: Extended;
    AJSearchTime: Extended;
    AJSearch: TTAJSearch;
    Search: TmTSearch;
    SearchO: TmTSearchO;
    SearchSJ: TmTSearchSJ;
    Search1J: TmTSearch1J;
    SearchText: String;
    SearchTextLen: Integer;
    aPattern: String;
    Identifiers: array[#0..#255]of ByteBool;
    List: TStringList;
    FileList: TStringList;
    function RndPat: String;
    procedure SearchTest;
    procedure SearchTestO;
    procedure SearchTestSJ;
    procedure SearchTest1J;
    procedure AJSearchTest;
    procedure Run1;
    procedure Run2;
    procedure MakeIdentTable;
    procedure FilterIdentifiers;
    function IsKeyWord(aToken: String): Boolean;
  public
    { Public-Deklarationen }
  end;

const
  Keywords: array[0..98]of string=
    ('ABSOLUTE', 'ABSTRACT', 'AND', 'ARRAY', 'AS', 'ASM', 'ASSEMBLER',
    'AUTOMATED', 'BEGIN', 'CASE', 'CDECL', 'CLASS', 'CONST', 'CONSTRUCTOR',
    'DEFAULT', 'DESTRUCTOR', 'DISPID', 'DISPINTERFACE', 'DIV', 'DO',
    'DOWNTO', 'DYNAMIC', 'ELSE', 'END', 'EXCEPT', 'EXPORT', 'EXPORTS',
    'EXTERNAL', 'FAR', 'FILE', 'FINALIZATION', 'FINALLY', 'FOR', 'FORWARD',
    'FUNCTION', 'GOTO', 'IF', 'IMPLEMENTATION', 'IN', 'INDEX', 'INHERITED',
    'INITIALIZATION', 'INLINE', 'INTERFACE', 'IS', 'LABEL', 'LIBRARY',
    'MESSAGE', 'MOD', 'NAME', 'NEAR', 'NIL', 'NODEFAULT', 'NOT', 'OBJECT',
    'OF', 'OR', 'OUT', 'OVERRIDE', 'PACKED', 'PASCAL', 'PRIVATE', 'PROCEDURE',
    'PROGRAM', 'PROPERTY', 'PROTECTED', 'PUBLIC', 'PUBLISHED', 'RAISE',
    'READ', 'READONLY', 'RECORD', 'REGISTER', 'REPEAT', 'RESIDENT',
    'RESOURCESTRING', 'SAFECALL', 'SET', 'SHL', 'SHR', 'STDCALL', 'STORED',
    'STRING', 'STRINGRESOURCE', 'THEN', 'THREADVAR', 'TO', 'TRY', 'TYPE',
    'UNIT', 'UNTIL', 'USES', 'VAR', 'VIRTUAL', 'WHILE', 'WITH', 'WRITE',
    'WRITEONLY', 'XOR');

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.MakeIdentTable;
var
  I: Char;
begin
  for I:=#0 to #255 do
  begin
    Case I of
      '_', '0'..'9', 'a'..'z', 'A'..'Z': Identifiers[I]:=True;
    else Identifiers[I]:=False;
    end;
  end;
end;

function TForm1.IsKeyWord(aToken: String): Boolean;
var
  First, Last, I, Compare: Integer;
  Token: String;
begin
  First:=0;
  Last:=98;
  Result:=False;
  Token:=UpperCase(aToken);
  while First<=Last do
  begin
    I:=(First+Last)shr 1;
    Compare:=CompareStr(Keywords[i], Token);
    if Compare=0 then
    begin
      Result:=True;
      break;
    end
    else
      if Compare<0 then First:=I+1 else Last:=I-1;
  end;
end; { IsKeyWord }

procedure TForm1.FilterIdentifiers;
var
  Len, Run, StartPos: integer;
  anIdentifier: String;
begin
  List.Clear;
  Run:=0;
  while Run<=SearchTextLen do
  begin
    if Identifiers[SearchText[Run]]then
    begin
      if SearchText[Run] in ['_', 'a'..'z', 'A'..'Z'] then
      begin
      StartPos:=Run;
      while Identifiers[SearchText[Run]]do
      begin
        inc(Run);
      end;
      Len:=Run-StartPos;
      if(Len>1)then
      begin
        anIdentifier:=Copy(SearchText, StartPos, Len);
        Case IsKeyWord(anIdentifier)of
          False: List.Add(anIdentifier);
        end;
      end;
      end else inc(Run);
    end else
      repeat
        inc(Run);
        if Run>SearchTextLen then break;
      until Identifiers[SearchText[Run]];
  end;
end;

function TForm1.RndPat: String;
var
  RndIndex: Integer;
begin
  Randomize;
  RndIndex:=random(List.Count-1);
  Result:=List[RndIndex];
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  MakeIdentTable;
  List:=TStringList.Create;
  FileList:=TStringList.Create;
  AJSearch:=TTAJSearch.Create;
  Search:=TmTSearch.Create;
  SearchO:=TmTSearchO.Create;
  SearchSJ:=TmTSearchSJ.Create;
  Search1J:=TmTSearch1J.Create;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  List.Free;
  FileList.Free;
  AJSearch.Free;
  Search.Free;
  SearchO.Free;
  SearchSJ.Free;
  Search1J.Free;
end;

procedure TForm1.AJSearchTest;
var
  Temp: Extended;
begin
  Time1.Start;
  AJSearch.FindFirst(SearchText);
  while not AJSearch.Finished do AJSearch.Next;
  Time1.Stop;
  Temp:=Time1.Elapsed;
  AJSearchTime:=AJSearchTime+Temp;
end;

procedure TForm1.SearchTest;
var
  Temp: Extended;
begin
  Time1.Start;
  Search.FindFirst(SearchText);
  while not Search.Finished do Search.Next;
  Time1.Stop;
  Temp:=Time1.Elapsed;
  SearchTime:=SearchTime+Temp;
end;

procedure TForm1.SearchTestO;
var
  Temp: Extended;
begin
  Time1.Start;
  SearchO.FindFirst(SearchText);
  while not SearchO.Finished do SearchO.Next;
  Time1.Stop;
  Temp:=Time1.Elapsed;
  SearchTimeO:=SearchTimeO+Temp;
end;

procedure TForm1.SearchTestSJ;
var
  Temp: Extended;
begin
  Time1.Start;
  SearchSJ.FindFirst(SearchText);
  while not SearchSJ.Finished do SearchSJ.Next;
  Time1.Stop;
  Temp:=Time1.Elapsed;
  SearchTimeSJ:=SearchTimeSJ+Temp;
end;

procedure TForm1.SearchTest1J;
var
  Temp: Extended;
begin
  Time1.Start;
  Search1J.FindFirst(SearchText);
  while not Search1J.Finished do Search1J.Next;
  Time1.Stop;
  Temp:=Time1.Elapsed;
  SearchTime1J:=SearchTime1J+Temp;
end;


procedure TForm1.Run1;
begin
  AJSearch.Init(aPattern);
  Search.Init(aPattern);
  SearchO.Init(aPattern);
  SearchSJ.Init(aPattern);
  Search1J.Init(aPattern);
  TempLen:=Length(SearchText);
  Searched:=Searched+Templen;
  SearchTest1J;
  SearchTest;
  SearchTestO;
  SearchTestSJ;
  AJSearchTest;
end;

procedure TForm1.Run2;
begin
  AJSearch.Init(aPattern);
  Search.Init(aPattern);
  SearchO.Init(aPattern);
  SearchSJ.Init(aPattern);
  Search1J.Init(aPattern);
  TempLen:=Length(SearchText);
  Searched:=Searched+Templen;
  AJSearchTest;
  SearchTestSJ;
  SearchTestO;
  SearchTest;
  SearchTest1J;
end;


{
SearchTest1J one purpose:

   To show how little the inner loop
   influences the search time.

   The first place is allways bad,
   the last the best.
   There fore are two runs with different
   orders

   This should show how to build a propper
   test case.
}

procedure TForm1.StartBtnClick(Sender: TObject);
var
  I: Integer;
  SearchRec: TSearchRec;
begin
  ListBox1.Items.Clear;
  FileList.Clear;
  FindFirst(DirectoryListBox1.Directory+'\*.pas', faAnyFile, SearchRec);
  FileList.Add(SearchRec.Name);
  if FileList.Count = 0 then exit;
  while FindNext(SearchRec)=0 do FileList.Add(SearchRec.Name);
  FindClose(SearchRec);
  ProgressBar1.Max:= FileList.Count;
  ProgressBar1.Position:=0;
  SearchTime1J:=0;
  SearchTime:=0;
  SearchTimeO:=0;
  SearchTimeSJ:=0;
  AJSearchTime:=0;
  Searched:=0;
  ListBox1.Items.BeginUpdate;
  for I:=0 to FileList.Count-1 do
  begin
    List.Clear;
    SearchText:='';
    List.LoadFromFile(FileList[I]);
    SearchText:=List.GetText;
    SearchTextLen:=Length(SearchText);
    FilterIdentifiers;
    aPattern:=RndPat;
    ListBox1.Items.Add(aPattern);
    Run1;
    Run2;
    ProgressBar1.Stepit;
  end;
  ListBox1.Items.EndUpdate;
  Edit1.Text:='Search: '+format('Seconds: %g', [SearchTime]);
  Edit2.Text:='Search0: '+format('Seconds: %g', [SearchTimeO]);
  Edit3.Text:='SearchSJ: '+format('Seconds: %g', [SearchTimeSJ]);
  Edit4.Text:='AJSearch: '+format('Seconds: %g', [AJSearchTime]);
  Edit5.Text:='Searched: '+FloatToStr(Searched/1048576)+' MB';
  Edit6.Text:='Search1J: '+format('Seconds: %g', [SearchTime1J]);
  ProgressBar1.Position:=0;
end;

procedure TForm1.DriveComboBox1Change(Sender: TObject);
begin
  DirectoryListBox1.Drive:=DriveComboBox1.Drive;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  I: Integer;
  SearchRec: TSearchRec;
begin
  FileList.Clear;
  FindFirst(DirectoryListBox1.Directory+'\*.pas', faAnyFile, SearchRec);
  FileList.Add(SearchRec.Name);
  if FileList.Count = 0 then exit;
  while FindNext(SearchRec)=0 do FileList.Add(SearchRec.Name);
  FindClose(SearchRec);
  ProgressBar1.Max:= FileList.Count;
  ProgressBar1.Position:=0;
  SearchTime1J:=0;
  SearchTime:=0;
  SearchTimeO:=0;
  SearchTimeSJ:=0;
  AJSearchTime:=0;
  Searched:=0;
  for I:=0 to FileList.Count-1 do
  begin
    List.Clear;
    SearchText:='';
    List.LoadFromFile(FileList[I]);
    SearchText:=List.GetText;
    SearchTextLen:=Length(SearchText);
    if Edit7.Text = '' then exit;
    aPattern:=Edit7.Text;
    Run1;
    Run2;
    ProgressBar1.Stepit;
  end;
  Edit1.Text:='Search: '+format('Seconds: %g', [SearchTime]);
  Edit2.Text:='Search0: '+format('Seconds: %g', [SearchTimeO]);
  Edit3.Text:='SearchSJ: '+format('Seconds: %g', [SearchTimeSJ]);
  Edit4.Text:='AJSearch: '+format('Seconds: %g', [AJSearchTime]);
  Edit5.Text:='Searched: '+FloatToStr(Searched/1048576)+' MB';
  Edit6.Text:='Search1J: '+format('Seconds: %g', [SearchTime1J]);
  ProgressBar1.Position:=0;
end;

procedure TForm1.ListBox1Click(Sender: TObject);
begin
  Edit7.Text:= ListBox1.Items[ListBox1.ItemIndex];
end;

end.

